| OpenCV 5.0.0alpha Open Source Computer Vision

Loading...
Searching...
No Matches
Public Member Functions | Static Public Member Functions | List of all members
cv::xfeatures2d::TBMR Class Referenceabstract
Extra 2D Features Framework » Experimental 2D Features Algorithms

Class implementing the Tree Based Morse Regions (TBMR) as described in [308] extended with scaled extraction ability. More...

`#include <opencv2/xfeatures2d.hpp>`

Collaboration diagram for cv::xfeatures2d::TBMR:

## Public Member Functions
String | getDefaultName () const CV_OVERRIDE
virtual float | getMaxAreaRelative () const =0
virtual int | getMinArea () const =0
virtual int | getNScales () const =0
virtual float | getScaleFactor () const =0
virtual void | setMaxAreaRelative (float maxArea)=0
virtual void | setMinArea (int minArea)=0
virtual void | setNScales (int n_scales)=0
virtual void | setScaleFactor (float scale_factor)=0
Public Member Functions inherited from cv::xfeatures2d::AffineFeature2D
virtual void | detect (InputArray image, std::vector< Elliptic_KeyPoint > &keypoints, InputArray mask=noArray())=0
| Detects keypoints in the image using the wrapped detector and performs affine adaptation to augment them with their elliptic regions.
virtual void | detect (InputArray image, std::vector< KeyPoint > &keypoints, InputArray mask=noArray())
| Detects keypoints in an image (first variant) or image set (second variant).
virtual void | detect (InputArrayOfArrays images, std::vector< std::vector< KeyPoint > > &keypoints, InputArrayOfArrays masks=noArray())
virtual void | detectAndCompute (InputArray image, InputArray mask, std::vector< Elliptic_KeyPoint > &keypoints, OutputArray descriptors, bool useProvidedKeypoints=false)=0
| Detects keypoints and computes descriptors for their surrounding regions, after warping them into circles.
virtual void | detectAndCompute (InputArray image, InputArray mask, std::vector< KeyPoint > &keypoints, OutputArray descriptors, bool useProvidedKeypoints=false)
Public Member Functions inherited from cv::Feature2D
virtual | ~Feature2D ()
virtual void | compute (InputArray image, std::vector< KeyPoint > &keypoints, OutputArray descriptors)
| Computes the descriptors for a set of keypoints detected in an image (first variant) or image set (second variant).
virtual void | compute (InputArrayOfArrays images, std::vector< std::vector< KeyPoint > > &keypoints, OutputArrayOfArrays descriptors)
virtual int | defaultNorm () const
virtual int | descriptorSize () const
virtual int | descriptorType () const
virtual bool | empty () const CV_OVERRIDE
| Return true if detector object is empty.
virtual void | read (const FileNode &) CV_OVERRIDE
| Reads algorithm parameters from a file storage.
void | read (const String &fileName)
void | write (const String &fileName) const
virtual void | write (FileStorage &) const CV_OVERRIDE
| Stores algorithm parameters in a file storage.
void | write (FileStorage &fs, const String &name) const
Public Member Functions inherited from cv::Algorithm
| Algorithm ()
virtual | ~Algorithm ()
virtual void | clear ()
| Clears the algorithm state.
virtual void | save (const String &filename) const
void | write (FileStorage &fs, const String &name) const

## Static Public Member Functions
static Ptr< TBMR > | create (int min_area=60, float max_area_relative=0.01f, float scale_factor=1.25f, int n_scales=-1)
Static Public Member Functions inherited from cv::xfeatures2d::AffineFeature2D
static Ptr< AffineFeature2D > | create (Ptr< FeatureDetector > keypoint_detector)
| Creates an instance where keypoint detector and descriptor extractor are identical.
static Ptr< AffineFeature2D > | create (Ptr< FeatureDetector > keypoint_detector, Ptr< DescriptorExtractor > descriptor_extractor)
| Creates an instance wrapping the given keypoint detector and descriptor extractor.
Static Public Member Functions inherited from cv::Algorithm
template<typename _Tp >
static Ptr< _Tp > | load (const String &filename, const String &objname=String())
| Loads algorithm from the file.
template<typename _Tp >
static Ptr< _Tp > | loadFromString (const String &strModel, const String &objname=String())
| Loads algorithm from a String.
template<typename _Tp >
static Ptr< _Tp > | read (const FileNode &fn)
| Reads algorithm from the file node.

## Additional Inherited Members
Protected Member Functions inherited from cv::Algorithm
void | writeFormat (FileStorage &fs) const

## Detailed Description

Class implementing the Tree Based Morse Regions (TBMR) as described in [308] extended with scaled extraction ability.

Parameters

  min_area | prune areas smaller than minArea
  max_area_relative | prune areas bigger than maxArea = max_area_relative * input_image_size
  scale_factor | scale factor for scaled extraction.
  n_scales | number of applications of the scale factor (octaves).

Note
  This algorithm is based on Component Tree (Min/Max) as well as MSER but uses a Morse-theory approach to extract features.

Features are ellipses (similar to MSER, however a MSER feature can never be a TBMR feature and vice versa).

## Member Function Documentation

## ◆ create()

static Ptr< TBMR > cv::xfeatures2d::TBMR::create | ( | int | min_area = 60,
|  | float | max_area_relative = 0.01f,
|  | float | scale_factor = 1.25f,
|  | int | n_scales = -1 )
| static

Python:
| cv.xfeatures2d.TBMR.create( | [, min_area[, max_area_relative[, scale_factor[, n_scales]]]] | ) -> | retval
| cv.xfeatures2d.TBMR_create( | [, min_area[, max_area_relative[, scale_factor[, n_scales]]]] | ) -> | retval

## ◆ getDefaultName()

String cv::xfeatures2d::TBMR::getDefaultName | ( |  | ) | const
| virtual

Python:
| cv.xfeatures2d.TBMR.getDefaultName( |  | ) -> | retval

Returns the algorithm string identifier. This string is used as top level xml/yml node tag when the object is saved to a file or string.

Reimplemented from cv::Feature2D.

## ◆ getMaxAreaRelative()

virtual float cv::xfeatures2d::TBMR::getMaxAreaRelative | ( |  | ) | const
| pure virtual

Python:
| cv.xfeatures2d.TBMR.getMaxAreaRelative( |  | ) -> | retval

## ◆ getMinArea()

virtual int cv::xfeatures2d::TBMR::getMinArea | ( |  | ) | const
| pure virtual

Python:
| cv.xfeatures2d.TBMR.getMinArea( |  | ) -> | retval

## ◆ getNScales()

virtual int cv::xfeatures2d::TBMR::getNScales | ( |  | ) | const
| pure virtual

Python:
| cv.xfeatures2d.TBMR.getNScales( |  | ) -> | retval

## ◆ getScaleFactor()

virtual float cv::xfeatures2d::TBMR::getScaleFactor | ( |  | ) | const
| pure virtual

Python:
| cv.xfeatures2d.TBMR.getScaleFactor( |  | ) -> | retval

## ◆ setMaxAreaRelative()

virtual void cv::xfeatures2d::TBMR::setMaxAreaRelative | ( | float | maxArea | ) |
| pure virtual

Python:
| cv.xfeatures2d.TBMR.setMaxAreaRelative( | maxArea | ) -> | None

## ◆ setMinArea()

virtual void cv::xfeatures2d::TBMR::setMinArea | ( | int | minArea | ) |
| pure virtual

Python:
| cv.xfeatures2d.TBMR.setMinArea( | minArea | ) -> | None

## ◆ setNScales()

virtual void cv::xfeatures2d::TBMR::setNScales | ( | int | n_scales | ) |
| pure virtual

Python:
| cv.xfeatures2d.TBMR.setNScales( | n_scales | ) -> | None

## ◆ setScaleFactor()

virtual void cv::xfeatures2d::TBMR::setScaleFactor | ( | float | scale_factor | ) |
| pure virtual

Python:
| cv.xfeatures2d.TBMR.setScaleFactor( | scale_factor | ) -> | None

The documentation for this class was generated from the following file:

- opencv2/xfeatures2d.hpp